/* Script generated by Pawn Studio */

#include <amxmodx>
#include <amxmisc>
#include <nvault>
#include <nvault_util>

#define PLUGIN	"Bank AP"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

native BB_get_user_ap( id );
native BB_set_user_ap( id , amount );

const maxPlayer = 33;

const MAX_LEN_STRUCT = 256;

enum structPlayer {
	accountCreated,
	accountName[ MAX_LEN_STRUCT ],
	accountPin[ MAX_LEN_STRUCT ],
	accountValue,
	accountLogged,
	accountTry,
	accountLimitValue,
	accountAuth,
	accountDebt
}

new vaultHandle;

new playersInformations[ maxPlayer ][ structPlayer ];

new iTransfer[ maxPlayer ];

public plugin_init(){
	
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_clcmd( "say /bank" , "bankMenu" );
	register_clcmd( "say_team /bank" , "bankMenu" );
	
	register_clcmd( "NumerPin" , "handlePinNumber" );
	register_clcmd( "PinNumberOld" , "handlePinNumberOld" );
	register_clcmd( "WplacMonety" , "handleWplacAmmo" );
	register_clcmd( "WyplacMonety" , "handleWyplacAmmo" );
	
	register_clcmd( "DebtGet" , "handleDebt" );
	
	vaultHandle = nvault_open( "BankDataBase" );
}

public plugin_end(){
	nvault_close( vaultHandle );
}

public client_connect( id ){
	clearUserInformations( id );
	
	new szName[ 256 ];
	
	get_user_name( id , szName , charsmax( szName ) );
	
	setAccountName( id , szName );
	
	loadUserInformations( id );
}

public client_disconnect( id ){
	saveUserInformations( id );
	
	clearUserInformations( id );
}

public bankMenu( id ){
	if( !getAccountCreated( id ) ){
		menuCreateAccount( id );
		
		return PLUGIN_HANDLED;
	}
	
	if( !getAccountLogged( id ) ){
	
		client_cmd( id , "messagemode NumerPin" );
	
		client_print( id , print_chat , "[BANK] Podaj numer pin" );
	
		return PLUGIN_HANDLED;
	}
	
	mainMenu( id );
	
	return PLUGIN_HANDLED;
}

public menuCreateAccount( id ){
	new pMenu = menu_create( "Tworzenie konta" , "menuCreateHandle" );
	
	menu_additem( pMenu , "Chesz zalozyc konto ?" );
	
	menu_setprop( pMenu , MPROP_BACKNAME , "Wyjdz" );
	
	menu_display( id , pMenu );
}

public menuCreateHandle( id , menu , item ){
	if( item == MENU_EXIT ){
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	
	if( item == 0 ){
		client_cmd( id , "messagemode NumerPin" );
		
		client_print( id , print_chat , "[BANK] Podaj kod pin do konta" );
	}
	
	menu_destroy( menu );
	return PLUGIN_HANDLED;
}

public handlePinNumberOld( id ){
	new szData[ 128 ];
	
	read_argv( 1 , szData , charsmax( szData ) );
	
	trim( szData );
	
	if( strlen( szData ) == 0 ){
		return PLUGIN_HANDLED;
	}
	
	new szPin[ MAX_LEN_STRUCT ];
	
	getAccountPin( id , szPin , charsmax( szPin ) );
	
	if( strcmp( szPin , szData ) != 0 ){
		client_print( id , print_chat , "[BANK] Zly stary pin" );
		
		setAccountAuth( id , false );
		
		return PLUGIN_HANDLED;
	}
	
	setAccountAuth( id , true );
	
	client_cmd( id , "messagemode NumerPin" );
	
	return PLUGIN_HANDLED;
}

public handlePinNumber( id ){
	new szData[ 128 ];
	
	read_argv( 1 , szData , charsmax( szData ) );
	
	trim( szData );
	
	if( strlen( szData ) == 0 ){
		return PLUGIN_HANDLED;
	}
	
	if( getAccountLogged( id ) ){
		if( getAccountAuth( id ) ){
			setAccountPin( id , szData );
			
			setAccountAuth( id , false );
		}
	}
	else if( getAccountCreated( id ) ){
		if( loginToAccount( id , szData ) ){
			client_print( id , print_chat , "[BANK] Zostales zalogowany" );
		}
		else{
			client_print( id , print_chat , "[BANK] Zly kod pin" );
			
			setAccountTry( id , getAccountTry( id ) + 1 );
			
			if( getAccountTry( id ) >= 3 ){
				new playerName[ 256 ];
				
				get_user_name( id , playerName , charsmax( playerName ) );
				
				server_cmd( "kick ^"%s^" ^"Zbyt duzo razy wpisywales zly kod pin^"" , playerName );
			}
		}
	}
	else {
		if( createAccount( id , szData) ){
			client_print( id , print_chat , "Konto zostalo utworzone i zostales zalogowany" );
		}
	}
	
	return PLUGIN_HANDLED;
}

public handleWplacAmmo( id ){
	if( !getAccountLogged( id ) ){
		return PLUGIN_HANDLED;
	}
	
	new szAmmount[ 16 ] ,
		iAmmount = 0,
		iDiffrenceAccount;
	
	read_argv( 1 , szAmmount , charsmax( szAmmount ) );
	
	trim( szAmmount );
	
	iAmmount = str_to_num( szAmmount );
	
	if( iAmmount <= 0 ){
		client_print( id , print_chat , "[BANK] Niepoprawna liczba monet" );
		
		return PLUGIN_HANDLED;
	}
	
	if( iAmmount > BB_get_user_ap( id ) ){
		iAmmount = BB_get_user_ap( id );
	}
	
	iDiffrenceAccount = getAccountLimit( id ) - getAccountValue( id );
	
	if( iDiffrenceAccount < iAmmount ){
		iAmmount = iDiffrenceAccount;
	}
	
	client_print( id , print_chat , "[BANK] Na konto przetransferowano %d monet. Do limitu na koncie zostalo %d monet" , getAccountLimit( id ) - getAccountValue( id ) ); 
	
	BB_set_user_ap( id , BB_get_user_ap( id ) - iAmmount );
	
	if( getAccountDebt( id ) > 0 ){
		if( getAccountDebt( id ) < iAmmount ){
			iAmmount -= getAccountDebt( id );
			
			setAccountDebt( id , 0 );
		}
		else {
			setAccountDebt( id , getAccountDebt( id ) - iAmmount );
			
			iAmmount = 0;
		}
	}
	
	setAccountValue( id , getAccountValue( id ) + iAmmount );
	
	return PLUGIN_HANDLED;
}

public handleWyplacAmmo( id ){
	if( !getAccountLogged( id ) ){
		return PLUGIN_HANDLED;
	}
	
	new szAmmount[ 16 ] ,
		iAmmount = 0;
	
	read_argv( 1 , szAmmount , charsmax( szAmmount ) );
	
	trim( szAmmount );
	
	iAmmount = str_to_num( szAmmount );
	
	if( iAmmount <= 0 ){
		client_print( id , print_chat , "[BANK] Niepoprawna liczba monet" );
		
		return PLUGIN_HANDLED;
	}
	
	if( iAmmount > getAccountValue( id ) ){
		iAmmount = getAccountValue( id );
	}
	
	setAccountValue( id , getAccountValue( id ) - iAmmount );
	
	BB_set_user_ap( id , BB_get_user_ap( id ) + iAmmount );
	
	client_print( id , print_chat , "[BANK] Wyplaciles %d monet" , iAmmount );
	
	return PLUGIN_HANDLED;
}

public handleDebt( id ){
	if( !getAccountLogged( id ) ){
		return PLUGIN_HANDLED;
	}
	
	new szAmmount[ 16 ] ,
		iAmmount = 0;
	
	read_argv( 1 , szAmmount , charsmax( szAmmount ) );
	
	trim( szAmmount );
	
	iAmmount = str_to_num( szAmmount );
	
	if( iAmmount <= 0 ){
		client_print( id , print_chat , "[BANK] Niepoprawna liczba monet" );
		
		return PLUGIN_HANDLED;
	}
	
	if( iAmmount > 40 || iAmmount + getAccountDebt( id ) > 40 ){
		client_print( id , print_chat , "[BANK] Mozesz sie zadluzyc maksymalnie do 40 monet" );
		
		return PLUGIN_HANDLED;
	}
	
	BB_set_user_ap( id , BB_get_user_ap( id ) + iAmmount );
	
	client_print( id , print_chat , "[BANK] Pozyczyles %d monet" , iAmmount );
	
	
	return PLUGIN_HANDLED;
}

public mainMenu( id ){
	
	new szDebt[ 128 ];
	
	formatex( szDebt , charsmax( szDebt ) , "/ Aktualnie pozyczyles %d monet" , getAccountDebt( id ) );
	
	new szTitle[ 256 ];
	
	formatex( szTitle , charsmax( szTitle ) , "Menu konta / LIMIT %d / ilosc monet %d %s" ,getAccountLimit( id ) , getAccountValue( id ) , getAccountDebt( id ) ? szDebt : "" );
	
	new pMenu = menu_create( szTitle , "mainMenuHandle" );
	
	menu_additem( pMenu , "Wplac monety" );
	menu_additem( pMenu , "Wyplac monety" );
	menu_additem( pMenu , "Ustawienia ( zmiana pinu )" );
	menu_additem( pMenu , "Ulepszenie Konta ( Zwiekszenie Limitu Banku )" );
	menu_additem( pMenu , "Najbogatsi Gracze Serwera" );
	menu_additem( pMenu , "Pozyczka" );
	
	menu_setprop( pMenu , MPROP_BACKNAME , "Wroc" );
	menu_setprop( pMenu , MPROP_NEXTNAME , "Dalej" );
	menu_setprop( pMenu , MPROP_EXITNAME , "Wyjdz" );
	
	menu_display( id , pMenu );
}

public mainMenuHandle( id , menu , item ){
	if( item == MENU_EXIT ){
		menu_destroy( menu );
		
		return PLUGIN_HANDLED;
	}
	
	switch( item ){
		case 0 : {
			client_print( id , print_chat , "[BANK] Ile chcesz wplacic monet ?" );
			
			client_cmd( id , "messagemode WplacMonety" );
		}
		case 1 : {
			client_print( id , print_chat , "[BANK] Ile chcesz wyplacic monety ?" );
			
			client_cmd( id , "messagemode WyplacMonety" );
		}
		case 2 : {
			setAccountAuth( id , false );
			
			client_print( id , print_chat , "[BANK] Wpisz stary pin" );
			
			client_cmd( id , "messagemode PinNumberOld" );
		}
		case 3 : {
			if( BB_get_user_ap( id ) < 100 ){
				client_print( id , print_chat , "[BANK] Masz za malo monet potrzebujesz 100" );
			}
			else if( getAccountLimit( id ) >= 10000 ){
				client_print( id , print_chat , "[BANK] Nie mozesz juz ulepszac konta" );
			}
			else {
				new iAddValue = 400;
				
				if( 10000 - getAccountLimit( id ) < 400 ){
					iAddValue = 10000 - getAccountLimit( id );
				}
				
				BB_set_user_ap( id , BB_get_user_ap( id ) - 100 );
				
				setAccountLimit( id , getAccountLimit( id ) + iAddValue );
				
				client_print( id , print_chat , "[BANK] Ulepszyles konto do %d limitu" , getAccountLimit( id ) );
			}
		}
		case 4 : {
			
			delete_file( "tmpAccount.html" );
			
			new handleUtil = nvault_util_open( "BankDataBase" );
			
			new iAmountTotal = nvault_util_count( handleUtil );
			
			new iRet , iPos;
			new szKey[ 256 ] , szData[ 256 ] , iTimeStamp;
			
			new szText[ 256 ];
			
			new accountInformation[ structPlayer ];
			
			new Array: arrayAccounts = ArrayCreate( 1 , sizeof accountInformation ); 
			
			new szPin[ 256 ] ,
				szValue[ 16 ] ,
				szLimit[ 16 ];
			
			for ( new iCurrent = 1 ; iCurrent <= iAmountTotal ; iCurrent++ ){
				new accountInformationSecond[ structPlayer ]; // Im really tired today sorry
				
				iPos = nvault_util_read( handleUtil , iPos , szKey , charsmax( szKey ) , szData , charsmax( szData ) , iTimeStamp );
					
				copy( accountInformationSecond[ accountName ] , MAX_LEN_STRUCT - 1 , szKey );
				
				replace_all( szData , charsmax( szData ) , "#" , " " );
	
				parse( szData , szPin , charsmax( szPin ) , szValue , charsmax( szValue ) , szLimit , charsmax( szLimit ) );
				
				accountInformationSecond[ accountValue ] = str_to_num( szValue );
				
				ArrayPushArray( arrayAccounts , accountInformationSecond );

			}
			
			new iBorder = min( 10 , ArraySize( arrayAccounts ) );
			
			for( new iCurrentElement = 0 ; iCurrentElement < iBorder ; iCurrentElement++ ){
				
				new iBiggestNow = 0 ,
					iID = -1;
				
				for( new iCurrentElement2 = 0 ; iCurrentElement2 < ArraySize( arrayAccounts ) ; iCurrentElement2++ ){
					ArrayGetArray( arrayAccounts , iCurrentElement2 , accountInformation );
					
					if( iBiggestNow < accountInformation[ accountValue ] ){
						iBiggestNow = accountInformation[ accountValue ];
						iID = iCurrentElement2;
					}
				}
				
				if( iID != -1 ){
					ArrayGetArray( arrayAccounts , iID , accountInformation );
					
					formatex( szText , charsmax( szText ) , "%d. %s - %d</br>" , iCurrentElement + 1 , accountInformation[ accountName ] , accountInformation[ accountValue ] );
				
					write_file( "tmpAccount.html" , szText ); 
					
					ArrayDeleteItem( arrayAccounts , iID );
				}
			}
			
			show_motd( id , "tmpAccount.html" , "10 Najbogatszych Graczy Serwera" );
			
			ArrayDestroy( arrayAccounts );
			
			nvault_util_close( handleUtil );
			
			#pragma unused iRet
		}
		case 5 : {
			client_print( id , print_chat , "[BANK] Mozesz sie zadluzyc maksymalnie do 40 monet" );
			
			client_cmd( id , "messagemode DebtGet" );
		}
	}
	
	menu_destroy( menu );
	
	return PLUGIN_HANDLED;
}

public sortDescending( Array: array , itemFirst , itemSecond ){
	new accountInformationFirst[ structPlayer ] ,
		accountInformationSecond[ structPlayer ];
		
	ArrayGetArray( array , itemFirst , accountInformationFirst );
	ArrayGetArray( array , itemSecond , accountInformationSecond );
	
	if( accountInformationFirst[ accountValue ] > accountInformationSecond[ accountValue ] ){
		return 1;
	}
	else if( accountInformationFirst[ accountValue ] < accountInformationSecond[ accountValue ] ){
		return -1;
	}
	
	
	return 0;
}

public menuTransfer( id ){
	new szName[ 256 ] ,
		szID[ 16 ];
	
	new pMenu = menu_create( "Wybierz gracza" , "menuTransferHandle" );
	
	for( new iPlayer = 1 ; iPlayer < maxPlayer ; iPlayer++ ){
		if( !is_user_connected( iPlayer ) || id == iPlayer || !getAccountLogged( iPlayer ) ){
			continue;
		}
		
		num_to_str( iPlayer , szID , charsmax( szID ) );
		
		get_user_name( iPlayer , szName , charsmax( szName ) );
		
		menu_additem( pMenu , szName , szID );
	}
	
	menu_display( id , pMenu );
}

public menuTransferHandle( id , menu , item ){
	if( item == MENU_EXIT ){
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	
	new access , szInfo[ 32 ], name[ 256 ] , callback;

	menu_item_getinfo( menu , item , access, szInfo , charsmax( szInfo ) , name , charsmax( name ) , callback );
	
	new idFound = str_to_num( szInfo );
	
	if( !is_user_connected( idFound ) || !getAccountLogged( idFound ) ){
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	
	client_print( id , print_chat , "[BANK] Ile chcesz przekazac ?" );
	
	iTransfer[ id ] = idFound;
	
	client_cmd( id , "messagemode TransferMonet" );
	
	menu_destroy( menu );
	return PLUGIN_HANDLED;
}

bool: loginToAccount( id , szData[] ){
	if( getAccountLogged( id ) ){
		return false;
	}
	
	new szPin[ MAX_LEN_STRUCT ];
	
	getAccountPin( id , szPin , charsmax( szPin ) );
	
	if( strcmp( szPin , szData ) != 0 ){
		
		return false;
	}
	
	setAccountLogged( id , true );
	setAccountTry( id , 0 );
	
	mainMenu( id );
	
	return true;
}

bool:createAccount( id , szPin[] ){
	if( getAccountCreated( id ) ){
		return false;
	}
	
	setAccountCreated( id , true );
	setAccountPin( id , szPin );
	setAccountLogged( id , true );
	setAccountLimit( id , 400 );
	setAccountDebt( id , 0 );
	
	return true;
}

loadUserInformations( id ){
	new szData[ 256 ],
		szKey[ MAX_LEN_STRUCT ];
		
	
	getAccountName( id , szKey , charsmax( szKey ) );
	
	nvault_get( vaultHandle , szKey , szData , charsmax( szData ) );
	
	if( strcmp( szData , "" ) == 0 ){
		setAccountCreated( id , false );
		
		return;
	}
	
	new szPin[ 256 ] ,
		szValue[ 16 ] ,
		szLimit[ 16 ] ,
		szDebt[ 16 ];
	
	replace_all( szData , charsmax( szData ) , "#" , " " );
	
	parse( szData , szPin , charsmax( szPin ) , szValue , charsmax( szValue ) , szLimit , charsmax( szLimit ) , szDebt , charsmax( szDebt ) );
	
	setAccountPin( id , szPin );
	setAccountValue( id , str_to_num( szValue ) );
	setAccountLimit( id , str_to_num( szLimit ) );
	setAccountDebt( id , str_to_num( szDebt ) );
	
	setAccountCreated( id , true );
	
}

saveUserInformations( id ){
	if( !getAccountLogged( id ) ){
		return ;
	}
	
	new szData[ 256 ],
		szKey[ MAX_LEN_STRUCT ];
	
	new pinNumber[ MAX_LEN_STRUCT ];
	
	getAccountName( id , szKey , charsmax( szKey ) );
	
	getAccountPin( id , pinNumber , charsmax( pinNumber ) );
	
	formatex( szData , charsmax( szData ) , "%s#%d#%d#%d" , pinNumber , getAccountValue( id ) , getAccountLimit( id ) , getAccountDebt( id ) );
	
	nvault_set( vaultHandle , szKey , szData );
}

setAccountName( id , szName[] ){
	copy( playersInformations[ id ][ accountName ] , MAX_LEN_STRUCT - 1 , szName );
}

getAccountName( id , szName[] , maxLen ){
	copy( szName , maxLen , playersInformations[ id ][ accountName ] );
}

setAccountCreated( id , bool:stateAccount ){
	playersInformations[ id ][ accountCreated ] = stateAccount;
}

bool:getAccountCreated( id ){
	return bool:playersInformations[ id ][ accountCreated ];
}

setAccountPin( id , szPin[] ){
	copy( playersInformations[ id ][ accountPin ] , MAX_LEN_STRUCT - 1 , szPin );
}

getAccountPin( id , szPin[] , maxLen ){
	copy( szPin , maxLen , playersInformations[ id ][ accountPin ] );
}

setAccountValue( id , value ){
	playersInformations[ id ][ accountValue ] = value;
}

getAccountValue( id ){
	return playersInformations[ id ][ accountValue ];
}

setAccountLogged( id , bool:stateAccount ){
	playersInformations[ id ][ accountLogged ] = stateAccount;
}

bool:getAccountLogged( id ){
	return bool:playersInformations[ id ][ accountLogged ];
}

setAccountTry( id , numberTry ){
	playersInformations[ id ][ accountTry ] = numberTry;
}

getAccountTry( id ){
	return playersInformations[ id ][ accountTry ];
}

setAccountLimit( id , numberLimit ){
	playersInformations[ id ][ accountLimitValue ] = numberLimit;
}

getAccountLimit( id ){
	return playersInformations[ id ][ accountLimitValue ];
}

setAccountAuth( id , bool:auth ){
	playersInformations[ id ][ accountAuth ] = auth;
}

bool: getAccountAuth( id ){
	return bool:playersInformations[ id ][ accountAuth ];
}

setAccountDebt( id , value ){
	playersInformations[ id ][ accountDebt ] = value;
}

getAccountDebt( id ){
	return playersInformations[ id ][ accountDebt ];
}

clearUserInformations( id ){
	setAccountCreated( id , false );
	setAccountName( id , "" );
	setAccountPin( id , "" );
	setAccountValue( id , 0 );
	setAccountLogged( id , false );
	setAccountTry( id , 0 );
	setAccountLimit( id , 0 );
	setAccountAuth( id , false );
	setAccountDebt( id , 0 );
}